Index: D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/core/src/com/icesoft/faces/context/DOMContext.java
===================================================================
--- D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/core/src/com/icesoft/faces/context/DOMContext.java	(revision 16406)
+++ D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/core/src/com/icesoft/faces/context/DOMContext.java	(working copy)
@@ -36,9 +36,17 @@
  */
 package com.icesoft.faces.context;
 
-import com.icesoft.faces.util.HalterDump;
-import com.icesoft.faces.webapp.http.common.Configuration;
-import com.icesoft.faces.webapp.http.common.ConfigurationException;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import javax.faces.component.UIComponent;
+import javax.faces.context.FacesContext;
+import javax.faces.context.ResponseWriter;
+
 import org.w3c.dom.DOMException;
 import org.w3c.dom.Document;
 import org.w3c.dom.Element;
@@ -47,15 +55,10 @@
 import org.w3c.dom.NodeList;
 import org.w3c.dom.Text;
 
-import javax.faces.component.UIComponent;
-import javax.faces.context.FacesContext;
-import javax.faces.context.ResponseWriter;
-import java.io.IOException;
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
+import com.icesoft.faces.renderkit.dom_html_basic.HTML;
+import com.icesoft.faces.util.HalterDump;
+import com.icesoft.faces.webapp.http.common.Configuration;
+import com.icesoft.faces.webapp.http.common.ConfigurationException;
 
 /**
  * <p><strong>DOMContext</strong> provides a component specific interface to the
@@ -408,8 +411,27 @@
         }
         return foundItems;
     }
-
-
+    
+    public static boolean hasChildWithName(Element root, String name, String tagName){
+    	NodeList list = root.getElementsByTagName(tagName);
+    	for( int i = 0 ; i < list.getLength() ; i++ ){
+    		if(((Element)list.item(i)).getAttribute("name").equalsIgnoreCase(name))
+    			return true;
+    	}
+    	return false;
+    }
+    
+    public Element createHiddenField(Element parent, String name){
+    	Element hiddenField = this.createElement(HTML.INPUT_ELEM);
+		hiddenField
+				.setAttribute(HTML.TYPE_ATTR, HTML.INPUT_TYPE_HIDDEN);
+		hiddenField.setAttribute(HTML.NAME_ATTR, name);
+		parent.appendChild(hiddenField);
+		return hiddenField;
+    }
+    
+    
+   
     private HashMap halterDumps = new HashMap();
 
     /**
Index: D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/core/src/com/icesoft/faces/renderkit/dom_html_basic/FormRenderer.java
===================================================================
--- D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/core/src/com/icesoft/faces/renderkit/dom_html_basic/FormRenderer.java	(revision 16406)
+++ D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/core/src/com/icesoft/faces/renderkit/dom_html_basic/FormRenderer.java	(working copy)
@@ -33,22 +33,25 @@
 
 package com.icesoft.faces.renderkit.dom_html_basic;
 
-import com.icesoft.faces.context.DOMContext;
-import com.icesoft.faces.context.effects.CurrentStyle;
-import com.icesoft.util.SeamUtilities;
-import org.apache.commons.logging.Log;
-import org.apache.commons.logging.LogFactory;
-import org.w3c.dom.Element;
+import java.io.IOException;
+import java.util.HashMap;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
 
 import javax.faces.FacesException;
 import javax.faces.component.UIComponent;
 import javax.faces.component.UIForm;
 import javax.faces.context.FacesContext;
-import java.io.IOException;
-import java.util.HashMap;
-import java.util.Iterator;
-import java.util.Map;
 
+import org.apache.commons.logging.Log;
+import org.apache.commons.logging.LogFactory;
+import org.w3c.dom.Element;
+
+import com.icesoft.faces.context.DOMContext;
+import com.icesoft.faces.context.effects.CurrentStyle;
+import com.icesoft.util.SeamUtilities;
+
 public class FormRenderer extends DomBasicRenderer {
 
     public static final String COMMAND_LINK_HIDDEN_FIELD =
@@ -278,15 +281,19 @@
             FacesContext facesContext, Map map) {
         DOMContext domContext =
                 DOMContext.getDOMContext(facesContext, uiComponent);
+        
         Element root = (Element) domContext.getRootNode();
         Iterator commandLinkFields = map.entrySet().iterator();
         while (commandLinkFields.hasNext()) {
             Map.Entry nextField = (Map.Entry) commandLinkFields.next();
             if (COMMAND_LINK_HIDDEN_FIELD.equals(nextField.getValue())) {
-                Element next = domContext.createElement("input");
-                next.setAttribute("type", "hidden");
-                next.setAttribute("name", nextField.getKey().toString());
-                root.appendChild(next);
+            	if( !DOMContext.hasChildWithName(root, nextField.getKey().toString(), "input") ){
+            		Element next = domContext.createElement("input");
+                    next.setAttribute("type", "hidden");
+                    next.setAttribute("name", nextField.getKey().toString());
+                    root.appendChild(next);
+            	}
+                
             }
         }
     }
Index: D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/tree/TreeRenderer.java
===================================================================
--- D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/tree/TreeRenderer.java	(revision 16406)
+++ D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/tree/TreeRenderer.java	(working copy)
@@ -152,22 +152,7 @@
             return;
         }
 
-        // set up form fields
-        FormRenderer.addHiddenField(facesContext,
-                                    CustomComponentUtils.getHiddenTreeExpandFieldName(
-                                            uiComponent.getClientId(
-                                                    facesContext),
-                                            CustomComponentUtils.getFormName(
-                                                    uiComponent,
-                                                    facesContext)));
-        FormRenderer.addHiddenField(facesContext,
-                                    CustomComponentUtils.getHiddenTreeActionFieldName(
-                                            uiComponent.getClientId(
-                                                    facesContext),
-                                            CustomComponentUtils.getFormName(
-                                                    uiComponent,
-                                                    facesContext)));
-
+       
         // encode the root DIV
         if (!domContext.isInitialized()) {
             Element rootDOMNode = domContext.createRootElement(HTML.DIV_ELEM);
@@ -176,7 +161,7 @@
         }
         // get the root node
         Element rootDomNode = (Element) domContext.getRootNode();
-
+        
         // Apply  default styleClass and style to the root node.
         rootDomNode
                 .setAttribute(HTML.CLASS_ATTR, treeComponent.getStyleClass());
@@ -188,7 +173,25 @@
 
         // clean up, and remove nodes
         DOMContext.removeChildren(rootDomNode);
+        
+     // set up form fields
+        domContext.createHiddenField(rootDomNode, CustomComponentUtils.getHiddenTreeExpandFieldName(
+                uiComponent.getClientId(
+                        facesContext),
+                CustomComponentUtils.getFormName(
+                        uiComponent,
+                        facesContext)));
+        
+        domContext.createHiddenField(rootDomNode, 
+                CustomComponentUtils.getHiddenTreeActionFieldName(
+                        uiComponent.getClientId(
+                                facesContext),
+                        CustomComponentUtils.getFormName(
+                                uiComponent,
+                                facesContext)));
 
+        
+
         if (PassThruAttributeRenderer.passThruAttributeExists(uiComponent)) {
             PassThruAttributeRenderer
                     .renderAttributes(facesContext, uiComponent, null);
Index: D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/panelcollapsible/PanelCollapsibleRenderer.java
===================================================================
--- D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/panelcollapsible/PanelCollapsibleRenderer.java	(revision 16406)
+++ D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/panelcollapsible/PanelCollapsibleRenderer.java	(working copy)
@@ -55,7 +55,7 @@
         //add click handler if not disabled and toggleOnClick is set to true
         if (panelCollapsible.isToggleOnClick() && 
         		!panelCollapsible.isDisabled()) {
-            FormRenderer.addHiddenField(facesContext, uiComponent.getClientId(facesContext)+ "Expanded");
+            domContext.createHiddenField(root, uiComponent.getClientId(facesContext)+ "Expanded");
             UIComponent form = findForm(uiComponent);
             if(form == null) {
                 throw new FacesException("PanelCollapsible must be contained within a form");                
Index: D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/paneltabset/PanelTabSetRenderer.java
===================================================================
--- D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/paneltabset/PanelTabSetRenderer.java	(revision 16406)
+++ D:/Documents and Settings/pbreau/workspace/icefaces-trunk-ossrepo/component/src/com/icesoft/faces/component/paneltabset/PanelTabSetRenderer.java	(working copy)
@@ -612,7 +612,7 @@
             String nextKey;
             while (parameterKeys.hasNext()) {
                 nextKey = (String) parameterKeys.next();
-                FormRenderer.addHiddenField(facesContext, nextKey);
+                domContext.createHiddenField(tr, nextKey);               
             }
 
         }
